      PROGRAM TZPBSV1
*
*       ணࠬ PZPBSV
*
      include 'mpif.h'
*  ⠭ - ࠬ  ..
      INTEGER            DLEN_, JA, IB, N, NB, RSRC, CSRC,
     $                   MXLLDA, MXLLDB, NRHS, NBRHS, NOUT,
     $                   MXLOCR, MXLOCC, MXRHSC, BW
      PARAMETER          ( DLEN_ = 7, JA = 1, IB = 1,
     $                   N = 9, NB = 3, RSRC = 0,
     $                   CSRC = 0, MXLLDA = 2, MXLLDB = 3, NRHS = 1,
     $                   NBRHS = 1, NOUT = 6, MXLOCR = 3, MXLOCC = 3,
     $                   MXRHSC = 1, BW = 1, LWORK = 6 )
      CHARACTER          UPLO
      PARAMETER          ( UPLO = 'L' )
*
*  ६
      INTEGER            ICTXT, INFO, MYCOL, MYROW, NPCOL, NPROW
*
*  ᨢ
      INTEGER            DESCA( DLEN_ ), DESCB( DLEN_ ), DESCD( 9 ),
     $                   DESCBP( 9 )
      DOUBLE COMPLEX     A( MXLLDA, MXLOCC ), B( MXLLDB, MXRHSC ),
     $                   WORK( LWORK ), WORK2( 9 )
*
* 譨 ணࠬ
      EXTERNAL           BLACS_EXIT, BLACS_GRIDEXIT, BLACS_GRIDINFO,
     $                   MATINIT, PZPBSV, SL_INIT, PZLAPRNT
*
*   DATA
      DATA               NPROW / 1 / , NPCOL / 3 /
*
* 믮塞 
*
* 樠 ⪨ ᮢ
*
      CALL SL_INIT( ICTXT, NPROW, NPCOL )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
*
* ᫨   ⪨ ᮢ, 室   ணࠬ
*
      IF( MYROW.EQ.-1 ) GO TO 10
*
* ।   ⪥ ᮢ
*
* 樠 ਯ஢   A  B
*
      DESCA(1) = 501
      DESCA(2) = ICTXT
      DESCA(3) = N
      DESCA(4) = NB
      DESCA(5) = CSRC
      DESCA(6) = 2
      DESCA(7) = 0
*
      CALL DESCINIT( DESCD, 2, N, 3, NB, RSRC, CSRC, ICTXT, 2, INFO )
*
      DESCB(1) = 502
      DESCB(2) = ICTXT
      DESCB(3) = N
      DESCB(4) = NB
      DESCB(5) = RSRC
      DESCB(6) = 3
      DESCB(7) = 0
*
      CALL DESCINIT( DESCBP, 1, N, 1, NB, RSRC, CSRC, ICTXT, 1, INFO )
*
*  室 
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = 9999 )
         WRITE( NOUT, FMT = 9998 )N, N, NB
         WRITE( NOUT, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NOUT, FMT = * ) ' 室  '
         WRITE( NOUT, FMT = 9988 ) UPLO, BW
         WRITE( NOUT, FMT = * ) '  DESCA'
         WRITE( NOUT, FMT = 9985 )DESCA
         WRITE( NOUT, FMT = * ) '  DESCB'
         WRITE( NOUT, FMT = 9985 )DESCB
         WRITE( NOUT, FMT = * ) '  DESCD'
         WRITE( NOUT, FMT = 9985 )DESCD
         WRITE( NOUT, FMT = * ) '  DESCBP'
         WRITE( NOUT, FMT = 9985 )DESCBP
      END IF
 9985 FORMAT( / 9I5 /)
 9988 FORMAT( / ' UPLO = ', A, '   BW =', I3 /)
*
*   A  B  ।  ⪥ ᮢ
*
      CALL MATINIT( N, A, DESCD, B, DESCBP )
*
*  室   A  B
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) ' A'
      END IF
      CALL PZLAPRNT( 2, N, A, 1, JA, DESCD, 0, 0, 'A', NOUT, WORK2 )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) ' B'
      END IF
      CALL PZLAPRNT( 1, N, B, 1, 1, DESCBP, 0, 0, 'B', NOUT, WORK2 )
*
* 맮 ணࠬ 
*
* 襭  ⥬ A * X = B
*
      CALL  PZPBSV ( UPLO, N, BW, NRHS, A, JA, DESCA,
     $               B, IB, DESCB, WORK, LWORK, INFO)
*
*  १⮢ X
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NOUT, FMT = * ) '  '
         WRITE( NOUT, FMT = 9996 )INFO
         WRITE( NOUT, FMT = * ) ' X'
      END IF
      CALL PZLAPRNT( 1, N, B, 1, 1, DESCBP, 0, 0, 'X', NOUT, WORK2 )
*
* ᢮  ⪨ ᮢ
*
* ᢮ ⥪ BLACS'
*
      CALL BLACS_GRIDEXIT( ICTXT )
   10 CONTINUE
*
* 室  BLACS
*
      CALL BLACS_EXIT( 0 )
*
 9999 FORMAT( / '   ணࠬ PZPBSV' )
 9998 FORMAT( / ' 襭 A X = B ,' //
     $       '  A - ନ⮢ 筠  ',
     $       I2, '  ', I2, ',' / '      ࠧ',
     $       '    ⮫栬 ', I2,' ⮫  ' /)
 9997 FORMAT( '   ', I2, ' ,',
     $       ' ࠧ  ࠧ஬ ', I2, '  ', I2 /)
 9996 FORMAT( / ' 祭 INFO  = ', I6 /)
      STOP
      END
*
      SUBROUTINE MATINIT( N, A, DESCD, B, DESCBP )
*
* MATINIT   ।  A  B
*          ⪥ ᮢ 1 x 3
*
* ࠬ
      INTEGER            DESCD( * ), DESCBP( * ), N
      DOUBLE COMPLEX     A( * ), B( * )
*
*  ६
      INTEGER            I, J
      DOUBLE COMPLEX     MO, T, Z
*
* 譨 ணࠬ
      EXTERNAL           PZELSET
*
* 믮塞 
*
      T = (2.0D0, 0.D0)
      Z = (0.0D0, 0.D0)
      MO = (-1.0D0, 0.D0)
*
      DO 10 J = 1, N
      DO 20 I = 1, 2
       CALL PZELSET( A, I, J, DESCD, Z )
   20 CONTINUE
       CALL PZELSET( B, 1, J, DESCBP, Z )
   10 CONTINUE
*
      DO 30 J = 1, N-1
      I = 1
      CALL PZELSET( A, I, J, DESCD, T )
   30 CONTINUE
*
      CALL PZELSET( A, 1, N, DESCD, (1.D0, 0.0D0) )
*
      DO 50 J = 1, N-1
        I = 2
        CALL PZELSET( A, I, J, DESCD, MO )
   50 CONTINUE
*
      CALL PZELSET( B, 1, N, DESCBP, (1.0D0, 0.0D0) )
*
      RETURN
      END
